#include "types.h"
#include "utils.h"
#include "../../payload/arm_user_bin.h"

#define FRAMEBUFFER_ADDRESS (0x14000000+0x38C0000)

void clearScreen(u32 color)
{
    u32* framebuffer = (u32*)FRAMEBUFFER_ADDRESS;
    int i;
    for(i = 0; i < 896 * 504; i++)
    {
        framebuffer[i] = color;
    }
}

static const u32 repairData_set_fault_behavior[] = {
    0xE59F3080, 0xE92D4030,  0xE5932000, 0xE1A04000,
    0xE5923054, 0xE1A05001,  0xE3530001, 0x0A000002,
    0xE1530000, 0xE3E00000,  0x18BD8030, 0xE354000D
};
static const u32 repairData_set_panic_behavior[] = {
    0xE3C22E21, 0xE5832194, 0xE5931194, 0xE12FFF1E,
    0xE59F301C, 0xE59FC01C, 0xE5932000, 0xE1A01000,
    0xE5923054, 0xE59C0000, 0xE3530001, 0x058C1000
};

void ICInvalidateRange(void *addr, u32 size)
{
    u32 address = ((u32)addr) & ~0x03;
    u32 address_end = (address + size + 3) & ~0x03;
    while(address < address_end)
    {
        asm volatile("MCR p15, 0, %0, c7, c5, 1" : : "r" (address));
        address += 4;
    }
}

void _main()
{
    //void (*ios_shutdown)(int) = (void (*)(int))0xFFFFDC48;
    void (*ios_dflush)(void *ptr, unsigned int len) = (void (*)(void *, unsigned int))0x081200F0;

    unsigned char test_buf[0x400];
    int (*read_otp_internal)(int index, void* out_buf, u32 size) = (int (*)(int, void*, u32)) 0x08120248;

    read_otp_internal(0, test_buf, sizeof(test_buf));

    m_memcpy((void*)0x00130000, test_buf, sizeof(test_buf));
    ios_dflush((void *)0x00130000, 0x400);


    *(volatile u32*)0x0012F000 = 0xDEADBEAF;
    ios_dflush((void*)0x0012F000, 0x20);

    void * pset_panic_behavior = (void*)0x08129724;
    m_memcpy(pset_panic_behavior, repairData_set_panic_behavior, sizeof(repairData_set_panic_behavior));
    void * pset_fault_behavior = (void*)0x081298BC;
    m_memcpy(pset_fault_behavior, repairData_set_fault_behavior, sizeof(repairData_set_fault_behavior));

    void * pUserBinSource = (void*)0x00148000;
    void * pUserBinDest = (void*)0x101312D0;
    m_memcpy(pUserBinDest, pUserBinSource, sizeof(arm_user_bin));

    ios_dflush(pset_panic_behavior, sizeof(repairData_set_panic_behavior));
    ios_dflush(pset_fault_behavior, sizeof(repairData_set_fault_behavior));
    ios_dflush(pUserBinDest, sizeof(arm_user_bin));

    ICInvalidateRange(pset_panic_behavior, sizeof(repairData_set_panic_behavior));
    ICInvalidateRange(pset_fault_behavior, sizeof(repairData_set_fault_behavior));
    ICInvalidateRange(pUserBinDest, sizeof(arm_user_bin));

    *(volatile u32*)0x0012F004 = 0xDEADBEAF;
    ios_dflush((void*)0x0012F004, 0x20);
}
